require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/timeout.ph';
require 'dev/ata/atascsi.ph';
require 'dev/ata/pmreg.ph';
unless(defined(&NO_AHCI_DEBUG)) {
    sub NO_AHCI_DEBUG () {	1;}
}
if(defined(&AHCI_DEBUG)) {
    eval 'sub DPRINTF () {( &m,  &f...)  &do {  &if (( &ahcidebug & ( &m)) == ( &m))  &printf( &f); }  &while (0);}' unless defined(&DPRINTF);
    eval 'sub AHCI_D_TIMEOUT () {0x;}' unless defined(&AHCI_D_TIMEOUT);
    eval 'sub AHCI_D_VERBOSE () {0x1;}' unless defined(&AHCI_D_VERBOSE);
    eval 'sub AHCI_D_INTR () {0x2;}' unless defined(&AHCI_D_INTR);
    eval 'sub AHCI_D_XFER () {0x8;}' unless defined(&AHCI_D_XFER);
} else {
    eval 'sub DPRINTF () {( &m,  &f...);}' unless defined(&DPRINTF);
}
unless(defined(&AHCI_CMD_LIST_FLAG_CFL)) {
    sub AHCI_CMD_LIST_FLAG_CFL () {	0x1f;}
}
unless(defined(&AHCI_CMD_LIST_FLAG_A)) {
    sub AHCI_CMD_LIST_FLAG_A () {	(1<<5);}
}
unless(defined(&AHCI_CMD_LIST_FLAG_W)) {
    sub AHCI_CMD_LIST_FLAG_W () {	(1<<6);}
}
unless(defined(&AHCI_CMD_LIST_FLAG_P)) {
    sub AHCI_CMD_LIST_FLAG_P () {	(1<<7);}
}
unless(defined(&AHCI_CMD_LIST_FLAG_R)) {
    sub AHCI_CMD_LIST_FLAG_R () {	(1<<8);}
}
unless(defined(&AHCI_CMD_LIST_FLAG_B)) {
    sub AHCI_CMD_LIST_FLAG_B () {	(1<<9);}
}
unless(defined(&AHCI_CMD_LIST_FLAG_C)) {
    sub AHCI_CMD_LIST_FLAG_C () {	(1<<10);}
}
unless(defined(&AHCI_CMD_LIST_FLAG_PMP)) {
    sub AHCI_CMD_LIST_FLAG_PMP () {	0xf000;}
}
unless(defined(&AHCI_CMD_LIST_FLAG_PMP_SHIFT)) {
    sub AHCI_CMD_LIST_FLAG_PMP_SHIFT () {	12;}
}
unless(defined(&AHCI_PRDT_FLAG_INTR)) {
    sub AHCI_PRDT_FLAG_INTR () {	(1<<31);}
}
unless(defined(&AHCI_MAX_PRDT)) {
    sub AHCI_MAX_PRDT () {	24;}
}
unless(defined(&AHCI_MAX_PORTS)) {
    sub AHCI_MAX_PORTS () {	32;}
}
unless(defined(&AHCI_DMA_MAP)) {
    sub AHCI_DMA_MAP {
	my($_adm) = @_;
	eval q((($_adm)-> &adm_map));
    }
}
unless(defined(&AHCI_DMA_DVA)) {
    sub AHCI_DMA_DVA {
	my($_adm) = @_;
	eval q((($_adm)-> ($adm_map->{dm_segs[0]}->{ds_addr})));
    }
}
unless(defined(&AHCI_DMA_KVA)) {
    sub AHCI_DMA_KVA {
	my($_adm) = @_;
	eval q((( &void *)($_adm)-> &adm_kva));
    }
}
if(defined(&AHCI_COALESCE)) {
}
unless(defined(&AP_S_NORMAL)) {
    sub AP_S_NORMAL () {	0;}
}
unless(defined(&AP_S_PMP_PROBE)) {
    sub AP_S_PMP_PROBE () {	1;}
}
unless(defined(&AP_S_PMP_PORT_PROBE)) {
    sub AP_S_PMP_PORT_PROBE () {	2;}
}
unless(defined(&AP_S_ERROR_RECOVERY)) {
    sub AP_S_ERROR_RECOVERY () {	3;}
}
unless(defined(&AP_S_FATAL_ERROR)) {
    sub AP_S_FATAL_ERROR () {	4;}
}
if(defined(&DIAGNOSTIC)) {
}
if(defined(&AHCI_DEBUG)) {
    eval 'sub PORTNAME {
        my($_ap) = @_;
	    eval q((($_ap)-> &ap_name));
    }' unless defined(&PORTNAME);
} else {
    eval 'sub PORTNAME {
        my($_ap) = @_;
	    eval q( &DEVNAME(($_ap)-> &ap_sc));
    }' unless defined(&PORTNAME);
}
unless(defined(&AHCI_F_NO_NCQ)) {
    sub AHCI_F_NO_NCQ () {	(1<<0);}
}
unless(defined(&AHCI_F_IPMS_PROBE)) {
    sub AHCI_F_IPMS_PROBE () {	(1<<1);}
}
unless(defined(&AHCI_F_NO_PMP)) {
    sub AHCI_F_NO_PMP () {	(1<<2);}
}
if(defined(&AHCI_COALESCE)) {
}
unless(defined(&DEVNAME)) {
    sub DEVNAME {
	my($_s) = @_;
	eval q((($_s)-> ($sc_dev->{dv_xname})));
    }
}
1;
